/**
		Album Cover Grabber - Grabs album covers automatically off the internet
		Copyright (C) 2002  Kevin M Schmidt

		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.

		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.bluedragontavern.albumgrabber.allmusic.pages;

import com.bluedragontavern.albumgrabber.util.HTML;
import com.bluedragontavern.albumgrabber.Album;
import com.bluedragontavern.albumgrabber.Constants;

import org.apache.regexp.*;


public class AlbumPage
	{
	private String html = null;
	private boolean imageAvailable = false;
	private String imageUrl = null;

	/**
		* Constructor
		*/
	public AlbumPage(String html)
				 throws Exception
		{
		this.html = html;

		RE findImageRE = new RE("<IMG.*?width=200.*?src=(.*?jpg)");
		imageAvailable = findImageRE.match(html);
		imageUrl = findImageRE.getParen(1);
		}

	/**
		* Process an album page
		* @param album DOCUMENT ME!
		* @return DOCUMENT ME!
		* @throws Exception DOCUMENT ME!
		*/
	public Album getAlbum(Album album)
						throws Exception
		{
		//If we find a direct match
		if (imageAvailable)
			{
			album.setImageUrl(imageUrl);

			if (Constants.DEBUG)
				System.out.println("AlbumPage:imageUrl = " + imageUrl);

			//If the found artist and album names are not set, then search the html
			if (album.getFoundArtistName() == null)
				{
				//Artist&nbsp;</TD><TD colspan=2 class="co1" WIDTH="487">
				//<a href="javascript:z('B4287gjerj6iw')">Aerosmith</a>

				RE artist = new RE("Artist.*?\\)\">(.*?)</a>");
				artist.match(html);
				album.setFoundArtistName(artist.getParen(1));

				if (Constants.DEBUG)
					System.out.println("AlbumPage:artistName = " +
											 album.getFoundArtistName());
				}

			if (album.getFoundAlbumName() == null)
				{
				RE albumTitle = new RE("Album Title.*?WIDTH=.*?>(.*?)</TD>");
				albumTitle.match(html);
				album.setFoundAlbumName(albumTitle.getParen(1));

				if (Constants.DEBUG)
					System.out.println("AlbumPage:albumName = " +
											 album.getFoundAlbumName());
				}

			//Mark the album as being found
			album.found();
			}

		return album;
		}
	}